		section code
		
		include 'dev8_keys_sbasic'
		include 'dev8_keys_qdos_sms'
		include 'dev8_keys_qdos_ioa'
		include 'dev8_keys_qdos_io'
		include 'dev8_keys_qlv'
		include 'dev8_keys_err'
		include 'dev8_keys_sys'
		
start:		
                movea.w sb.inipr,a2    
                lea     fonted_procs(pc),a1
                jsr     (a2)
                rts
; ---------------------------------------------------------------------------
fonted_procs:   dc.w 8                  
                dc.w reset-*            ; RESET megabytes - QDOS only!
                dc.b 5,'RESET'
                dc.w purge-*            ; PURGE - Remove job or crash(?) if Basic
                dc.b 5,'PURGE'
                dc.w use-*              ; USE(#ch) - Use #ch as #1
                dc.b 3,'USE'
                dc.w replace-*          ; REPLACE search-name,replace-name - replace name in basic code
                dc.b 7,'REPLACE'
                dc.w poke$-*            ; POKE_$ addr, str$
                dc.b 6,'POKE_$',0
                dc.w keyboard-*         ; KEYBOARD delay, time
                dc.b 8,'KEYBOARD',0
                dc.w freeze-*           ; FREEZE 0/1
                dc.b 6,'FREEZE',0
                dc.w capslock-*         ; CAPSLOCK 0/1
                dc.b 8,'CAPSLOCK',0
                dc.w 0
                dc.w 13
                dc.w check_float-*      ; val = CHECK_FLOAT(str$) - get float value or -1E600 on error
                dc.b 6,'CHECKF',0
                dc.w check_int-*        ; val% = CHECK_INT(str$) - get int value or -32768 on error
                dc.b 6,'CHECK%',0
                dc.w pick$-*            ; str$ = PICK$(param_index, str1$, str2$, str3$, ...) - pick one of the string parameters
                dc.b 5,'PICK$'
                dc.w chan_b-*           ; val = CHAN_B(#ch, offset)
                dc.b 7,'CHAN_B%'
                dc.w chan_w-*           ; val = CHAN_W(#ch, offset)
                dc.b 7,'CHAN_W%'
                dc.w chan_l-*           ; val = CHAN_L(#ch, offset)
                dc.b 6,'CHAN_L',0
                dc.w peek$-*            ; str$ = PEEK_$(addr)
                dc.b 6,'PEEK_$',0
                dc.w edline$-*          ; str$ = EDLINE$(#ch, max, str$)
                dc.b 7,'EDLINE$'
                dc.w upper$-*           ; str$ = UPPER$(str$)
                dc.b 6,'UPPER$',0
                dc.w lower$-*           ; str$ = LOWER$(str$)
                dc.b 6,'LOWER$',0
                dc.w qdos$-*            ; ver$ = QDOS$
                dc.b 5,'QDOS$'
                dc.w qptr$-*            ; ver$ = QPTR$
                dc.b 5,'QPTR$'
                dc.w net-*              ; node = NET%
                dc.b 4,'NET%',0
                dc.w 0

; =============== S U B R O U T I N E =======================================
; USE(#ch) - Use #ch as #1

use:                                    
                cmpa.l  a3,a5
                bne.s   use_params

use_ch1:                                
                movea.l sb_chanb(a6),a1 ; long    channel table base
                lea     ch.len(a1),a1   ; #1
                move.l  #$10001,ch_chid(a1,a6.l) ; Fixed channel ID 1
                moveq   #4,d0           ; Clear 5 long words

use_clear:                              
                addq.l  #4,a1
                clr.l   (a1,a6.l)       ; Clear ch_grphy, ch_grphx, ch_angle and ch_pdwn
                dbf     d0,use_clear
                moveq   #80,d0
                move.l  d0,4(a1,a6.l)   ; ch_colmn = 0, ch_width = 80
                bra.s   use_ok
; ---------------------------------------------------------------------------

use_params:                             
                lea     8(a3),a0        ; First param
                cmpa.l  a0,a5
                bne.s   use_ipar
                movea.w sb.gtint,a2    
                jsr     (a2)
                bne.s   use_ret
                move.w  (a1,a6.l),d0    ; Channel number
                cmpi.w  #1,d0
                beq.s   use_ch1
                movea.l sb_chanb(a6),a1 ; long    channel table base
                moveq   #ch.len,d1
                mulu.w  d1,d0
                add.l   a1,d0           ; #n
                cmp.l   sb_chanp(a6),d0 ; long    channel table pointer
                bge.s   use_ichn
                move.l  ch_chid(a6,d0.l),d5 ; long    channel ID, -1 if unset
                bmi.s   use_ichn
                add.l   a1,d1           ; #1
                moveq   #ch.len/4-1,d2

use_copy:                               
                move.l  (a6,d0.l),(a6,d1.l)
                addq.l  #4,d0
                addq.l  #4,d1
                dbf     d2,use_copy

use_ok:                                 
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

use_ichn:                               
                moveq   #err.ichn,d0    ; Invalid CHaNnel id
                rts
; ---------------------------------------------------------------------------

use_ipar:                               
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)

use_ret:                                
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; RESET megabytes - QDOS only!

reset:                                  
                cmpa.l  a5,a3
                beq.s   reset_do
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                moveq   #8,d1
                add.l   a3,d1
                sub.l   a5,d1
                bne.s   reset_ret
                movea.w sb.gtint,a2    
                jsr     (a2)
                bne.s   reset_ret
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                moveq   #0,d1
                move.w  (a6,a1.l),d1    ; Kilobytes
                cmp.w   #64,d1
                blt.s   reset_ret
                cmp.w   #640,d1
                bhi.s   reset_ret
                divu.w  #32,d1          ; /32
                swap    d1
                tst.w   d1
                bne.s   reset_ret       ; Must be divisable by 32
                swap    d1
                mulu.w  #32,d1
                addi.w  #128,d1         ; + base of RAM
                mulu.w  #1024,d1        ; In bytes
                movea.l d1,a1
                movea.l a1,a4
                movea.l 4,a0            ; RESET vector
                adda.l  #$1A,a0         ; QDOS ROM offset into reset after RAM size check. BAAAAAD!
                trap    #0
                move    #$2700,sr
                move.b  #$13,-1(a4)
                cmpi.b  #$13,-1(a4)
                bne.s   reset_do2
                jsr     (a0)

reset_do:                               
                trap    #0
                move    #$2700,sr

reset_do2:                              
                reset

reset_ret:                              
                rts
; ---------------------------------------------------------------------------

purge:                                  
                moveq   #0,d1           ; PURGE - Remove job or crash(?) if Basic
                moveq   #0,d2
                moveq   #sms.injb,d0    ; get INformation on JoB
                trap    #1
                move.l  d1,d0           ; Job ID
                beq.s   purge_basic     ; Doesn't make sense
                moveq   #0,d3
                moveq   #sms.frjb,d0    ; Forced Remove JoB
                trap    #1
                bra.s   purge           ; PURGE - Remove job or crash(?) if Basic
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; POKE_$ addr, str$

poke$:                                  
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                move.l  a5,d1
                sub.l   a3,d1
                subi.l  #16,d1
                bne     poke$_ret
                movem.l a3/a5,-(sp)
                subq.l  #8,a5
                movea.w sb.gtlin,a0    
                jsr     (a0)
                bne     poke$_ret
                movea.l (a6,a1.l),a4
                movem.l (sp)+,a3/a5
                addq.l  #8,a3
                movea.w sb.gtstr,a0    
                jsr     (a0)
                bne     poke$_ret
                move.w  (a6,a1.l),d3
                move.w  d3,(a4)+

purge_basic:                            
                addq.w  #1,d3
                andi.w  #$FFFE,d3

poke$_loop:                             
                addq.l  #2,a1
                move.w  (a6,a1.l),(a4)+
                subq.w  #2,d3
                bne     poke$_loop
                clr.l   d0

poke$_ret:                              
                rts

; =============== S U B R O U T I N E =======================================
; str$ = PEEK_$(addr)

peek$:                                  
                movea.w sb.gtlin,a0    
                jsr     (a0)
                bne     peek$_ret
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmp.w   #1,d3
                bne     peek$_ret
                movea.l (a6,a1.l),a4
                move.w  (a4),d1
                addq.w  #3,d1
                andi.l  #$FFFE,d1
                move.l  d1,d4
                movea.w qa.resri,a0    
                jsr     (a0)
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                suba.l  d4,a1
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                move.w  (a4)+,d1
                move.w  d1,(a6,a1.l)
                addq.l  #2,a1

peek$_loop:                             
                move.b  (a4)+,(a6,a1.l)
                addq.l  #1,a1
                dbf     d1,peek$_loop
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                moveq   #1,d4
                clr.l   d0

peek$_ret:                              
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; REPLACE search-name,replace-name - replace name in basic code

replace:                                
                lea     16(a3),a0
                cmpa.l  a0,a5
                beq.s   replace_get_names

replace_ipar:                           
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                rts
; ---------------------------------------------------------------------------

replace_get_names:                      
                move.w  nt_name(a3,a6.l),d1 ; Name to look for
                bmi.s   replace_ipar
                move.w  nt_name+8(a3,a6.l),d2 ; Name to replace it with
                bmi.s   replace_ipar
                movea.l sb_srceb(a6),a0 ; long    source program base
                move.l  sb_srcep(a6),d7 ; long    source program pointer

replace_skip2:                          
                addq.l  #2,a0

replace_next:                           
                cmp.l   a0,d7
                bls.s   replace_ok
                move.b  (a0,a6.l),d0
                addq.l  #2,a0
                cmpi.b  #$EF,d0         ; Not sure why EF here
                bls.s   replace_check_token
                addq.l  #4,a0           ; Skip floating point
                bra.s   replace_next
; ---------------------------------------------------------------------------

replace_check_token:                    
                cmpi.b  #$88,d0         ; Name token?
                bne.s   replace_check_str
                cmp.w   (a0,a6.l),d1    ; Our source name?
                bne.s   replace_skip2
                move.w  d2,(a0,a6.l)    ; Yes, replace with other name
                bra.s   replace_skip2
; ---------------------------------------------------------------------------

replace_check_str:                      
                cmpi.b  #$8B,d0         ; String token?
                beq.s   replace_str
                cmpi.b  #$8C,d0         ; Text token?
                bne.s   replace_check_symbol

replace_str:                            
                moveq   #3,d0
                add.w   (a0,a6.l),d0
                bclr    #0,d0
                adda.w  d0,a0
                bra.s   replace_next
; ---------------------------------------------------------------------------

replace_check_symbol:                   
                cmpi.b  #$84,d0         ; Symbol token?
                bne.s   replace_check_lno
                cmpi.b  #$A,-1(a0,a6.l) ; End of line?
                bne.s   replace_next
                bra.s   replace_skip2
; ---------------------------------------------------------------------------

replace_check_lno:                      
                cmpi.b  #$8D,d0         ; Line number?
                bne.s   replace_next
                move.w  (a0,a6.l),d5    ; Line number in d5
                bra.s   replace_skip2
; ---------------------------------------------------------------------------

replace_ok:                             
                moveq   #0,d0

replace_ret:                            
                rts
; ---------------------------------------------------------------------------

check_ret:                              
                rts

; =============== S U B R O U T I N E =======================================
; val = CHECK_FLOAT(str$) - get float value or -1E600 on error

check_float:                            
                moveq   #0,d5
                bra.s   check_all

; =============== S U B R O U T I N E =======================================
; val% = CHECK_INT(str$) - get int value or -32768 on error

check_int:                              
                moveq   #1,d5

check_all:                              
                movea.l sb_arthp(a6),a4 ; long    arithmetic stack pointer
                movea.w sb.gtstr,a0    
                jsr     (a0)
                bne.s   check_ret
                subq.w  #1,d3           ; Only one parameter
                bne.s   replace_ret
                movea.l a1,a0
                adda.w  (a1,a6.l),a0
                addq.l  #2,a0
                move.l  a0,d7           ; End of string
                lea     2(a1),a0        ; String contents
                tst.w   d5
                beq.s   check_f
                moveq   #2,d1
                suba.l  d1,a4
                movea.w qa.resri,a2    
                jsr     (a2)
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                movea.w cv.deciw,a2    
                jsr     (a2)
                beq.s   check_int_ok
                move.w  #-32768,(a4,a6.l)
                bra.s   check_int_ret
; ---------------------------------------------------------------------------

check_int_ok:                           
                move.w  (a1,a6.l),(a4,a6.l)

check_int_ret:                          
                move.l  a4,sb_arthp(a6) ; long    arithmetic stack pointer
                moveq   #nt.in,d4
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

check_f:                                
                moveq   #6,d1
                suba.l  d1,a4
                movea.w qa.resri,a3    
                jsr     (a3)
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                movea.w cv.decfp,a2    
                jsr     (a2)
                beq.s   check_f_ok
                move.w  #$FCA,(a4,a6.l) ; -1E600
                move.w  #$B8A6,2(a4,a6.l)
                move.w  #$3468,4(a4,a6.l)
                bra.s   check_f_ret
; ---------------------------------------------------------------------------

check_f_ok:                             
                move.l  2(a1,a6.l),2(a4,a6.l)
                move.w  (a1,a6.l),(a4,a6.l)

check_f_ret:                            
                move.l  a4,sb_arthp(a6) ; long    arithmetic stack pointer
                moveq   #nt.fp,d4
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; val = CHAN_L(#ch, offset)

chan_l:                                 
                moveq   #-1,d5
                bra.s   chan_all

; =============== S U B R O U T I N E =======================================
; val = CHAN_W(#ch, offset)

chan_w:                                 
                moveq   #1,d5
                bra.s   chan_all

; =============== S U B R O U T I N E =======================================
; val = CHAN_B(#ch, offset)

chan_b:                                 
                moveq   #0,d5

chan_all:                               
                lea     16(a3),a0       ; Two params
                cmpa.l  a0,a5
                beq.s   chan_get_pars

chan_ipar:                              
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)

chan_ret:                               
                rts
; ---------------------------------------------------------------------------

chan_get_pars:                          
                movea.w sb.gtint,a2    
                jsr     (a2)
                bne.s   chan_ret
                move.w  (a1,a6.l),d0
                addq.l  #2,a1
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                move.w  (a1,a6.l),d1
                mulu.w  #ch.len,d0
                add.l   sb_chanb(a6),d0 ; long    channel table base
                cmp.l   sb_chanp(a6),d0 ; long    channel table pointer
                bge.s   chan_ichn
                move.l  (a6,d0.l),d0    ; Channel ID
                bpl.s   chan_exists

chan_ichn:                              
                moveq   #err.ichn,d0    ; Invalid CHaNnel id
                rts
; ---------------------------------------------------------------------------

chan_exists:                            
                movea.l d0,a0
                move.w  d5,d2           ; <0 = long, 0 = byte, >0 = word
                beq.s   chan_byte
                btst    #0,d1
                bne.s   chan_ipar

chan_byte:                              
                lea     xtop_chan(pc),a2
                moveq   #-1,d3
                moveq   #iow.xtop,d0    ; eXTernal OPeration on screen
                trap    #3
                tst.l   d0
                bne.s   chan_ret
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                tst.w   d5
                bmi.s   chan_long_to_fp
                move.w  d1,(a1,a6.l)
                moveq   #nt.in,d4
                rts
; ---------------------------------------------------------------------------

chan_long_to_fp:                        
                move.w  d1,d4
                move.l  d1,d5
                beq.s   chan_ret_fp
                move.w  #$81F,d4
                add.l   d1,d1
                bvs.s   chan_ret_fp
                subq.w  #1,d4
                move.l  d1,d5
                moveq   #$10,d0

chan_fp_loop:                           
                move.l  d5,d1
                asl.l   d0,d1
                bvs.s   chan_fp_bit
                sub.w   d0,d4
                move.l  d1,d5

chan_fp_bit:                            
                asr.w   #1,d0
                bne.s   chan_fp_loop

chan_ret_fp:                            
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                moveq   #4,d1
                movea.w qa.resri,a0    
                jsr     (a0)
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                subq.w  #4,a1
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                move.l  d5,2(a1,a6.l)
                move.w  d4,(a1,a6.l)
                moveq   #nt.fp,d4
                bra.s   chan_ok
; ---------------------------------------------------------------------------

xtop_chan:                              
                tst.w   d2              ; <0 = long, 0 = byte, >0 = word
                beq.s   xtop_chan_b
                bmi.s   xtop_chan_l
                move.w  (a0,d1.w),d1
                bra.s   chan_ok
; ---------------------------------------------------------------------------

xtop_chan_l:                            
                move.l  (a0,d1.w),d1
                bra.s   chan_ok
; ---------------------------------------------------------------------------

xtop_chan_b:                            
                moveq   #0,d2
                move.b  (a0,d1.w),d2
                move.w  d2,d1

chan_ok:                                
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; str$ = PICK$(param_index, str1$, str2$, str3$, ...) - pick one of the string parameters

pick$:                                  
                cmpa.l  a3,a5
                beq.s   pick$_ipar
                move.l  a5,d5           ; Remember top of parameters
                lea     8(a3),a5
                movea.w sb.gtint,a2    
                jsr     (a2)
                bne.s   pick$_ret
                move.w  (a1,a6.l),d0
                ble.s   pick$_ipar
                addq.l  #2,a1
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                asl.w   #3,d0           ; *8
                bvs.s   pick$_ipar
                adda.w  d0,a5           ; Index into string parameter list
                cmpa.l  d5,a5
                bhi.s   pick$_ipar
                lea     -8(a5),a3
                movea.w sb.gtstr,a2    
                jsr     (a2)
                bne.s   pick$_ret
                moveq   #nt.st,d4
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

pick$_ipar:                             
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)

pick$_ret:                              
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; str$ = EDLINE$(#ch, max, str$)

edline$:                                
                move.l  a5,d5
                lea     24(a3),a5       ; 3 parameters
                cmp.l   a5,d5
                bne.s   edline_ipar
                subq.l  #8,a5
                movea.w sb.gtint,a2    
                jsr     (a2)
                bne.s   edline_ret
                addq.l  #4,sb_arthp(a6) ; long    arithmetic stack pointer
                move.w  2(a1,a6.l),d7   ; Max string length
                movea.l a5,a3
                movea.l d5,a5
                move.w  2(a1,a6.l),d7   ; Two times' the charm apparently
                move.w  (a1,a6.l),d0    ; Channel number
                mulu.w  #ch.len,d0
                add.l   sb_chanb(a6),d0 ; long    channel table base
                cmp.l   sb_chanp(a6),d0 ; long    channel table pointer
                bge.s   edline_ichn
                move.l  ch_chid(a6,d0.l),d5 ; Channel ID
                bmi.s   edline_ichn
                movea.w sb.gtstr,a2     ; Get string parameter
                jsr     (a2)
                bne.s   edline_ret
                addq.w  #1,d7
                move.l  sb_cmdlb(a6),d0 ; long    command line (parsed) buffer base
                subq.l  #8,d0
                sub.l   sb_buffb(a6),d0
                cmp.w   d0,d7
                bcs.s   edline_do
                moveq   #err.bffl,d0    ; BuFfer FuLl
                rts
; ---------------------------------------------------------------------------

edline_ichn:                            
                moveq   #err.ichn,d0    ; Invalid CHaNnel id
                rts
; ---------------------------------------------------------------------------

edline_ipar:                            
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)

edline_ret:                             
                rts
; ---------------------------------------------------------------------------

edline_trap3:                           
                trap    #3
                tst.l   d0
                beq.s   edline_trap_ret
                addq.l  #4,sp

edline_trap_ret:                        
                rts
; ---------------------------------------------------------------------------

edline_do:                              
                lea     2(a1),a0        ; Ptr to stack characters
                movea.l sb_buffb(a6),a2
                addq.l  #8,a2           ; Leave space fro CHRQ block
                move.w  (a1,a6.l),d2    ; Size of string
                move.w  d2,d6
                movea.l a2,a1           ; Buffer string pointer
                cmp.w   d7,d6           ; More than max size?
                bcc.s   edline_ipar
                bsr     copy_mem        ; Copy string from stack into buffer
                move.l  a0,d4           ; Ptr to stack characters
                moveq   #-1,d3
                movea.l d5,a0           ; Channel ID
                move.l  a1,d5
                movea.l sb_buffb(a6),a1
                trap    #4
                moveq   #iow.chrq,d0    ; Get window size/character position
                bsr.s   edline_trap3

edline_loop:                            
                movea.l sb_buffb(a6),a1
                move.w  4(a6,a1.l),d1   ; Cursor X pos
                swap    d2              ; Size of string in upper word
                move.w  6(a6,a1.l),d2   ; Cursor Y pos
                moveq   #iow.scur,d0    ; Set CURsor position (character coordinates)
                bsr.s   edline_trap3
                swap    d2
                movea.l d5,a1           ; Buffer string pointer
                trap    #4
                moveq   #iob.smul,d0    ; Send MULtiple bytes
                bsr.s   edline_trap3
                moveq   #' ',d1
                moveq   #iob.sbyt,d0    ; Send BYTe to output
                bsr.s   edline_trap3
                moveq   #iow.pcol,d0    ; move cursor to Previous COLumn
                bsr.s   edline_trap3
                move.w  d2,d1           ; Cursor at end of string
                swap    d1
                move.w  d2,d1           ; Line length
                movea.l sb_buffb(a6),a1
                lea     8(a1,d1.w),a1   ; Skip CHRQ block
                move.w  d7,d2           ; Length of buffer
                trap    #4
                moveq   #iob.elin,d0    ; Edit LINe of characters
                trap    #3
                tst.l   d0
                bpl.s   edline_ret_str
                cmpi.w  #err.nc,d0      ; operation Not Complete
                bne.s   edline_check_bffl
                moveq   #iow.dcur,d0    ; Disable CURsor
                bsr.s   edline_trap3
                moveq   #err.nc,d0      ; operation Not Complete

edline_ret2:                            
                rts
; ---------------------------------------------------------------------------

edline_check_bffl:                      
                cmpi.w  #err.bffl,d0    ; BuFfer FuLl
                bne.s   edline_ret2
                subq.w  #1,d1

edline_retry:                           
                move.w  d1,d2
                bra.s   edline_loop
; ---------------------------------------------------------------------------

edline_ret_str:                         
                subq.w  #1,d1
                subq.l  #1,a1
                cmpi.b  #$A,(a6,a1.l)   ; Enter at end?
                bne.s   edline_retry    ; No, retry
                subq.l  #2,d4           ; Ptr to stack string
                move.l  d4,sb_arthp(a6) ; long    arithmetic stack pointer
                move.w  d1,d6           ; Edited string length
                ext.l   d1
                movea.w qa.resri,a2    
                jsr     (a2)
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                suba.l  d6,a1
                btst    #0,d6
                beq.s   edline_even
                subq.l  #1,a1

edline_even:                            
                move.w  d6,(a1,a6.l)    ; New string length
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                movea.l sb_buffb(a6),a0
                addq.l  #8,a0           ; Skip CHRQ buffer
                lea     2(a1),a2
                moveq   #nt.st,d4
                moveq   #0,d0

; =============== S U B R O U T I N E =======================================
; Copy D6 bytes from (a6,a0) to (a6,a2)

copy_mem:                               
                subq.w  #1,d6
                bmi.s   copy_mem_ret
                lsr.w   #1,d6

copy_mem_loop:                          
                move.w  (a6,a0.l),(a6,a2.l)
                addq.l  #2,a2
                addq.l  #2,a0
                dbf     d6,copy_mem_loop

copy_mem_ret:                           
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; str$ = UPPER$(str$)

upper$:                                 
                movea.w sb.gtstr,a0    
                jsr     (a0)
                tst.l   d0
                bne     upper_ret
                cmpi.w  #1,d3
                bne     upper_ipar
                movea.l a1,a4
                adda.l  a6,a4
                move.w  (a4)+,d0
                tst.w   d0
                beq     upper_ret_str
                subq.w  #1,d0

upper_loop:                             
                move.b  (a4),d1
                cmpi.b  #'a',d1
                blt     upper_next
                cmpi.b  #'z',d1
                bgt     upper_next
                subi.b  #32,d1

upper_next:                             
                move.b  d1,(a4)+
                dbf     d0,upper_loop

upper_ret_str:                          
                moveq   #0,d0
                moveq   #1,d4
                rts
; ---------------------------------------------------------------------------

upper_ipar:                             
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)

upper_ret:                              
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; str$ = LOWER$(str$)

lower$:                                 
                movea.w sb.gtstr,a0    
                jsr     (a0)
                tst.l   d0
                bne     lower_ret
                cmpi.w  #1,d3
                bne     lower_ipar
                movea.l a1,a4
                adda.l  a6,a4
                move.w  (a4)+,d0
                tst.w   d0
                beq     lower_ret_str
                subq.w  #1,d0

lower_loop:                             
                move.b  (a4),d1
                cmpi.b  #'A',d1
                blt     lower_next
                cmpi.b  #'Z',d1
                bgt     lower_next
                addi.b  #32,d1

lower_next:                             
                move.b  d1,(a4)+
                dbf     d0,lower_loop

lower_ret_str:                          
                moveq   #0,d0
                moveq   #nt.st,d4
                rts
; ---------------------------------------------------------------------------

lower_ipar:                             
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)

lower_ret:                              
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; ver$ = QDOS$

qdos$:                                  
                bsr     resri_6
                moveq   #sms.info,d0    ; get INFOrmation on SMS
                trap    #1
                move.w  #4,(a6,a5.l)
                move.l  d2,2(a6,a5.l)
                bra     ret_str

; =============== S U B R O U T I N E =======================================
; ver$ = QPTR$

qptr$:                                  
                bsr     resri_6
                moveq   #iop.pinf,d0    ; pointer information
                moveq   #-1,d3
                lea     0,a0    
                trap    #3
                tst.l   d0
                beq     qptr_ok
                move.w  #0,(a6,a5.l)
                bra     ret_str
; ---------------------------------------------------------------------------

qptr_ok:                                
                move.w  #4,(a6,a5.l)
                move.l  d1,2(a6,a5.l)
                bra     ret_str

; =============== S U B R O U T I N E =======================================

resri_6:                                
                moveq   #6,d1
                movea.w qa.resri,a4    
                jsr     (a4)
                movea.l sb_arthp(a6),a5 ; long    arithmetic stack pointer
                rts
; ---------------------------------------------------------------------------
ret_str:                                
                moveq   #nt.st,d4
                moveq   #0,d0
                move.l  a5,sb_arthp(a6) ; long    arithmetic stack pointer
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; KEYBOARD delay, time

keyboard:                               
                movea.w sb.gtint,a0    
                jsr     (a0)
                tst.l   d0
                bne     keyboard_ret
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmpi.w  #2,d3
                beq     keyboard_para2
                bgt     keyboard_ret
                cmpi.w  #0,d3
                bgt     keyboard_ret
                bne     keyboard_para2
                move.w  #30,d3          ; Repeat delay
                move.w  #2,d4           ; Repeat time
                bra     keyboard_set
; ---------------------------------------------------------------------------

keyboard_para2:                         
                move.w  (a6,a1.l),d3    ; Repeat delay
                move.w  2(a6,a1.l),d4   ; Repeat time

keyboard_set:                           
                moveq   #sms.info,d0    ; get INFOrmation on SMS
                trap    #1
                adda.w  #sys_rdel,a0    ; Repeat DELay (20ms units)
                move.w  d3,(a0)+
                move.w  d4,(a0)
                clr.l   d0

keyboard_ret:                           
                rts
; ---------------------------------------------------------------------------
                dc.w 0

; =============== S U B R O U T I N E =======================================
; FREEZE 0/1

freeze:                                 
                movea.w sb.gtint,a0    
                jsr     (a0)
                tst.l   d0
                bne     freeze_ret
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmpi.w  #1,d3
                bne     freeze_ret
                bsr     sms_info
                tst.w   (a6,a1.l)
                beq     freeze_clear
                move.b  #$FF,sys_dfrz(a0) ; Display FRoZen (T or F)
                bra     freeze_ok
; ---------------------------------------------------------------------------

freeze_clear:                           
                move.b  #0,sys_dfrz(a0) ; Display FRoZen (T or F)

freeze_ok:                              
                moveq   #0,d0

freeze_ret:                             
                rts

; =============== S U B R O U T I N E =======================================
; CAPSLOCK 0/1

capslock:                               
                movea.w sb.gtint,a0    
                jsr     (a0)
                tst.l   d0
                bne     capslock_ret
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmpi.w  #1,d3
                bne     capslock_ret
                bsr     sms_info
                tst.w   (a6,a1.l)
                beq     capslock_clear
                move.w  #$FFFF,sys_caps(a0) ; CAPS lock
                bra     capslock_ok
; ---------------------------------------------------------------------------

capslock_clear:                         
                move.w  #0,sys_caps(a0) ; CAPS lock

capslock_ok:                            
                moveq   #0,d0

capslock_ret:                           
                rts

; =============== S U B R O U T I N E =======================================
; node = NET%

net:                                    
                bsr     sms_info
                move.b  sys_nnnr(a0),d4 ; Network Node NumbeR
                andi.w  #$FF,d4
                movea.w qa.resri,a0    
                moveq   #2,d0
                jsr     (a0)
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                move.w  d4,(a6,a1.l)
                moveq   #0,d0
                moveq   #nt.in,d4
                rts

; =============== S U B R O U T I N E =======================================

sms_info:                               
                moveq   #0,d0
                trap    #1
                rts
; ---------------------------------------------------------------------------
                dc.w 0


                END
